Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -2473,359 +2591,388 @@
 
 
-       INTEGER ::  i, j, k, tn = 0
-       REAL    ::  gu, gv, flux_l, flux_s, flux_d, diss_l, diss_s, diss_d,    &
-                   u_comp, w_comp
+       INTEGER ::  i, j, k, tn = 0, k_ppp, k_pp, k_mm
+       REAL    ::  gu, gv, flux_d, diss_d, u_comp, w_comp, div
        REAL, DIMENSION(nzb+1:nzt) :: swap_flux_y_local_v, swap_diss_y_local_v
        REAL, DIMENSION(nzb+1:nzt,nys:nyn) :: swap_flux_x_local_v,             &
                                              swap_diss_x_local_v
-       REAL, DIMENSION(nzb:nzt+1) :: flux_t, diss_t, flux_n, diss_n, flux_r,  &
-                                     diss_r, v_comp
+       REAL, DIMENSION(nzb:nzt) :: flux_t, diss_t, flux_n, diss_n, flux_r,    &
+                                   diss_r, v_comp
 
        gu = 2.0 * u_gtrans
        gv = 2.0 * v_gtrans
 !
-!-- First compute the whole left boundary of the processor domain
+!--    First compute the whole left boundary of the processor domain
        i = nxl
        DO  j = nysv, nyn
-       
-          IF ( boundary_flags(j,i) == 6 )  THEN
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
-                swap_flux_x_local_v(k,j) = u_comp *                           &
-                                           ( v(k,j,i) + v(k,j,i-1)) * 0.25
-                swap_diss_x_local_v(k,j) = diss_2nd( v(k,j,i+2), v(k,j,i+1),  &
-                                                     v(k,j,i), v(k,j,i-1),    &
-                                                     v(k,j,i-1), u_comp,      &
-                                                     0.25, ddx )
+          DO  k = nzb+1, nzb_max
+
+             u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
+             swap_flux_x_local_v(k,j) = u_comp * (                             &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( v(k,j,i)   + v(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( v(k,j,i+1) + v(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( v(k,j,i+2) + v(k,j,i-3) )               &
+                                                 )
+
+              swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1 &
+                          ) *                                                  &
+                                     ( v(k,j,i)   - v(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( v(k,j,i+1) - v(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( v(k,j,i+2) - v(k,j,i-3) )               &
+                                                           )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
+             swap_flux_x_local_v(k,j) = u_comp * (                            &
+                             37.0 * ( v(k,j,i) + v(k,j,i-1)   )               &
+                           -  8.0 * ( v(k,j,i+1) + v(k,j,i-2) )               &
+                           +        ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
+             swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
+                             10.0 * ( v(k,j,i) - v(k,j,i-1)   )               &
+                           -  5.0 * ( v(k,j,i+1) - v(k,j,i-2) )               &
+                           +        ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+
+          ENDDO
+
+       ENDDO
+
+       DO i = nxl, nxr
+
+          j = nysv
+          DO  k = nzb+1, nzb_max
+
+             v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
+             swap_flux_y_local_v(k) = v_comp(k) * (                           &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( v(k,j,i)   + v(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( v(k,j+1,i) + v(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( v(k,j+2,i) + v(k,j-3,i) )              &
+                                                 )
+
+             swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( v(k,j,i)   - v(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( v(k,j+1,i) - v(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( v(k,j+2,i) - v(k,j-3,i) )              &
+                                                          )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
+             swap_flux_y_local_v(k) = v_comp(k) * (                           &
+                           37.0 * ( v(k,j,i) + v(k,j-1,i)   )                 &
+                         -  8.0 * ( v(k,j+1,i) + v(k,j-2,i) )                 &
+                         +        ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+             swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                  &
+                           10.0 * ( v(k,j,i) - v(k,j-1,i)   )                 &
+                         -  5.0 * ( v(k,j+1,i) - v(k,j-2,i) )                 &
+                         +        ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+
+          ENDDO
+
+          DO  j = nysv, nyn
+
+             flux_t(0) = 0.0
+             diss_t(0) = 0.0
+             flux_d    = 0.0
+             diss_d    = 0.0
+
+             DO  k = nzb+1, nzb_max
+
+                u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp * (                                       &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j,i+1) + v(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j,i+2) + v(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j,i+3) + v(k,j,i-2) )                 &
+                                     )
+
+                diss_r(k) = - ABS( u_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),18,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j,i+1) - v(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),19,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j,i+2) - v(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),20,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j,i+3) - v(k,j,i-2) )                 &
+                                              )
+
+                v_comp(k) = v(k,j+1,i) + v(k,j,i)
+                flux_n(k) = ( v_comp(k) - gv ) * (                           &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j+1,i) + v(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j+2,i) + v(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j+3,i) + v(k,j-2,i) )                 &
+                                     )
+
+                diss_n(k) = - ABS( v_comp(k) - gv ) * (                      &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),21,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( v(k,j+1,i) - v(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),22,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( v(k,j+2,i) - v(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),23,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( v(k,j+3,i) - v(k,j-2,i) )                 &
+                                                      )
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),26,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),24,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),26,1)
+
+                w_comp    = w(k,j-1,i) + w(k,j,i)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   + v(k,j,i)    )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  + v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) + v(k_mm,j,i) )                  &
+                                      )
+
+                diss_t(k) = - ABS( w_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   - v(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  - v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) - v(k_mm,j,i) )                  &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx &
+                     +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy &
+                     +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) )         &
+                                                                  ) * ddzw(k) &
+                      ) * 0.5
+
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                       ( flux_r(k) + diss_r(k)                                &
+                     -   swap_flux_x_local_v(k,j) - swap_diss_x_local_v(k,j)  &
+                       ) * ddx                                                &
+                     + ( flux_n(k) + diss_n(k)                                &
+                     -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
+                       ) * ddy                                                &
+                     + ( flux_t(k) + diss_t(k)                                &
+                     -   flux_d    - diss_d                                   &
+                       ) * ddzw(k)                                            &
+                                            )  + v(k,j,i) * div
+
+                swap_flux_x_local_v(k,j) = flux_r(k)
+                swap_diss_x_local_v(k,j) = diss_r(k)
+                swap_flux_y_local_v(k)   = flux_n(k)
+                swap_diss_y_local_v(k)   = diss_n(k)
+                flux_d                   = flux_t(k)
+                diss_d                   = diss_t(k)
+
+!
+!--             Statistical Evaluation of v'v'. The factor has to be applied
+!--             for right evaluation when gallilei_trans = .T. .
+                sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                     &
+                      + ( flux_n(k)                                           &
+                      * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                    &
+                      / ( v_comp(k) - gv + 1.0E-20 )                          &
+                      +   diss_n(k)                                           &
+                      *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )               &
+                      / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                  &
+                      *   weight_substep(intermediate_timestep_count)
+!
+!--              Statistical Evaluation of w'v'.
+                 sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                  &
+                              + ( flux_t(k) + diss_t(k) )                     &
+                              *   weight_substep(intermediate_timestep_count)
+
              ENDDO
-             
-          ELSE
-          
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
-                swap_flux_x_local_v(k,j) = u_comp * (                          &
-                                           37.0 * ( v(k,j,i) + v(k,j,i-1)   )  &
-                                         -  8.0 * ( v(k,j,i+1) + v(k,j,i-2) )  &
-                                         +        ( v(k,j,i+2) + v(k,j,i-3) ) )&
-                                         * adv_mom_5
-                swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                 &
-                                           10.0 * ( v(k,j,i) - v(k,j,i-1)   )  &
-                                         -  5.0 * ( v(k,j,i+1) - v(k,j,i-2) )  &
-                                         +        ( v(k,j,i+2) - v(k,j,i-3) ) )&
-                                         * adv_mom_5
+
+             DO  k = nzb_max+1, nzt
+
+                u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp * (                                        &
+                      37.0 * ( v(k,j,i+1) + v(k,j,i)   )                      &
+                    -  8.0 * ( v(k,j,i+2) + v(k,j,i-1) )                      &
+                    +        ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
+
+                diss_r(k) = - ABS( u_comp ) * (                               &
+                      10.0 * ( v(k,j,i+1) - v(k,j,i) )                        &
+                    -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )                      &
+                    +        ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
+
+
+                v_comp(k) = v(k,j+1,i) + v(k,j,i)
+                flux_n(k) = ( v_comp(k) - gv ) * (                            &
+                      37.0 * ( v(k,j+1,i) + v(k,j,i)   )                      &
+                    -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )                      &
+                      +      ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
+
+                diss_n(k) = - ABS( v_comp(k) - gv ) * (                       &
+                      10.0 * ( v(k,j+1,i) - v(k,j,i)   )                      &
+                    -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )                      &
+                    +        ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),26,1)
+                k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),24,1)  )
+                k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),26,1)
+
+                w_comp    = w(k,j-1,i) + w(k,j,i)
+                flux_t(k) = w_comp  * (                                      &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   + v(k,j,i)    )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  + v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) + v(k_mm,j,i) )                  &
+                                 )
+
+                diss_t(k) = - ABS( w_comp ) * (                              &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),24,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( v(k+1,j,i)   - v(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),25,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( v(k_pp,j,i)  - v(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),26,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( v(k_ppp,j,i) - v(k_mm,j,i) )                  &
+                                         )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx &
+                     +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy &
+                     +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) ) )       &
+                                                                    * ddzw(k) &
+                      ) * 0.5
+ 
+                tend(k,j,i) = tend(k,j,i) - (                                 &
+                       ( flux_r(k) + diss_r(k)                                &
+                     -   swap_flux_x_local_v(k,j) - swap_diss_x_local_v(k,j)  &
+                       ) * ddx                                                &
+                     + ( flux_n(k) + diss_n(k)                                &
+                     -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
+                       ) * ddy                                                &
+                     + ( flux_t(k) + diss_t(k)                                &
+                     -   flux_d    - diss_d                                   &
+                       ) * ddzw(k)                                            &
+                                            )  + v(k,j,i) * div
+
+                swap_flux_x_local_v(k,j) = flux_r(k)
+                swap_diss_x_local_v(k,j) = diss_r(k)
+                swap_flux_y_local_v(k)   = flux_n(k)
+                swap_diss_y_local_v(k)   = diss_n(k)
+                flux_d                   = flux_t(k)
+                diss_d                   = diss_t(k)
+
+!
+!--             Statistical Evaluation of v'v'. The factor has to be applied
+!--             for right evaluation when gallilei_trans = .T. .
+                sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                     &
+                         + ( flux_n(k)                                        &
+                         * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                 &
+                         / ( v_comp(k) - gv + 1.0E-20 )                       &
+                         +   diss_n(k)                                        &
+                         *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )            &
+                         / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )               &
+                         *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of w'v'.
+                sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
+                              + ( flux_t(k) + diss_t(k) )                      &
+                              *   weight_substep(intermediate_timestep_count)
+
              ENDDO
-             
-          ENDIF
-          
+          ENDDO
        ENDDO
-
-       DO i = nxl, nxr
-         j = nysv
-         IF ( boundary_flags(j,i) == 7 )  THEN
-         
-            DO  k = nzb_v_inner(j,i)+1, nzt
-               v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
-               swap_flux_y_local_v(k) = v_comp(k) *                           &
-                                        ( v(k,j,i) + v(k,j-1,i) ) * 0.25
-               swap_diss_y_local_v(k) = diss_2nd( v(k,j+2,i), v(k,j+1,i),     &
-                                                  v(k,j,i), v(k,j-1,i),       &
-                                                  v(k,j-1,i), v_comp(k),      &
-                                                  0.25, ddy )                                
-            ENDDO
-            
-         ELSE
-         
-            DO  k = nzb_v_inner(j,i)+1, nzt
-               v_comp(k)              = v(k,j,i) + v(k,j-1,i) - gv
-               swap_flux_y_local_v(k) = v_comp(k) * (                          &
-                                        37.0 * ( v(k,j,i) + v(k,j-1,i)   )     &
-                                      -  8.0 * ( v(k,j+1,i) + v(k,j-2,i) )     &
-                                      +        ( v(k,j+2,i) + v(k,j-3,i) ) )   &
-                                      * adv_mom_5
-               swap_diss_y_local_v(k) = - ABS( v_comp(k) ) * (                 &
-                                        10.0 * ( v(k,j,i) - v(k,j-1,i)   )     &
-                                      -  5.0 * ( v(k,j+1,i) - v(k,j-2,i) )     &
-                                      +        ( v(k,j+2,i) - v(k,j-3,i) ) )   &
-                                      * adv_mom_5
-            ENDDO
-            
-         ENDIF
-         
-         DO  j = nysv, nyn
-            IF ( boundary_flags(j,i) /= 0 )  THEN
-!       
-!--       Degrade the order for Dirichlet bc. at the outflow boundary
-               SELECT CASE ( boundary_flags(j,i) )
-          
-                  CASE ( 1 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt
-                        u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp * (                                 &
-                                    7.0 * (v(k,j,i+1) + v(k,j,i)    )          &
-                                  -       ( v(k,j,i+2) + v(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp ) * (                        &
-                                    3.0 * ( v(k,j,i+1) - v(k,j,i)   )          & 
-                                  -       ( v(k,j,i+2) - v(k,j,i-1) ) )        &
-                                  * adv_mom_3
-                     ENDDO
-                
-                  CASE ( 2 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt
-                        u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp * ( v(k,j,i+1) + v(k,j,i) ) * 0.25 
-                        diss_r(k) = diss_2nd( v(k,j,i+1), v(k,j,i+1),         &
-                                              v(k,j,i), v(k,j,i-1),           &
-                                              v(k,j,i-2), u_comp, 0.25, ddx )
-                     ENDDO
-                
-                  CASE ( 3 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt
-                        v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                        flux_n(k) = ( v_comp(k)- gv ) * (                     &
-                                    7.0 * ( v(k,j+1,i) + v(k,j,i)   )         &
-                                  -       ( v(k,j+2,i) + v(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS(v_comp(k) - gv) * (                 &
-                                    3.0 * ( v(k,j+1,i) - v(k,j,i)   )         & 
-                                  -       ( v(k,j+2,i) - v(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-                
-                  CASE ( 4 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt
-                        v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                        flux_n(k) = ( v_comp(k) - gv ) *                      &
-                                   ( v(k,j+1,i) + v(k,j,i) ) * 0.25 
-                        diss_n(k) = diss_2nd( v(k,j+1,i), v(k,j+1,i),         &
-                                              v(k,j,i), v(k,j-1,i),           &
-                                              v(k,j-2,i), v_comp(k), 0.25, ddy)
-                     ENDDO
-                
-                  CASE ( 5 )
-                     DO  k = nzb_w_inner(j,i)+1, nzt
-                        u_comp    = u(k,j-1,i) + u(k,j,i) - gu 
-                        flux_r(k) = u_comp * (                                &
-                                    7.0 * ( v(k,j,i+1) + v(k,j,i)   )         &
-                                  -       ( v(k,j,i+2) + v(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS (u_comp ) * (                       &
-                                    3.0 * ( w(k,j,i+1) - w(k,j,i)   )         & 
-                                  -       ( v(k,j,i+2) - v(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-                 
-                  CASE ( 6 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt
-                                  
-                        u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                        flux_r(k) = u_comp * (                                &
-                                    7.0 * ( v(k,j,i+1) + v(k,j,i)   )         &
-                                  -       ( v(k,j,i+2) + v(k,j,i-1) ) )       &
-                                  * adv_mom_3
-                        diss_r(k) = - ABS( u_comp ) * (                       &
-                                    3.0 * ( v(k,j,i+1) - v(k,j,i)   )         & 
-                                  -       ( v(k,j,i+2) - v(k,j,i-1) ) )       &
-                                  * adv_mom_3 
-                     ENDDO
-                
-                  CASE ( 7 )
-                     DO  k = nzb_v_inner(j,i)+1, nzt                                 
-                        v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                        flux_n(k) = ( v_comp(k) - gv ) * (                    &
-                                    7.0 * ( v(k,j+1,i) + v(k,j,i)   )         &
-                                  -       ( v(k,j+2,i) + v(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                        diss_n(k) = - ABS( v_comp(k) - gv ) * (               &
-                                    3.0 * ( v(k,j+1,i) - v(k,j,i)   )         & 
-                                  -       ( v(k,j+2,i) - v(k,j-1,i) ) )       &
-                                  * adv_mom_3
-                     ENDDO
-                
-                  CASE DEFAULT
-              
-               END SELECT
-!          
-!--            Compute the crosswise 5th order fluxes at the outflow
-               IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2 .OR.&
-                    boundary_flags(j,i) == 5 .OR. boundary_flags(j,i) == 6 )   &
-               THEN
-          
-                  DO  k = nzb_v_inner(j,i)+1, nzt
-                     v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                     flux_n(k) = ( v_comp(k) - gv ) * (                       &
-                                 37.0 * ( v(k,j+1,i) + v(k,j,i)   )           &
-                               -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )           &
-                               +        ( v(k,j+3,i) + v(k,j-2,i) ) )         &
-                               * adv_mom_5
-                     diss_n(k) = - ABS( v_comp(k) - gv ) * (                  &
-                                 10.0 * ( v(k,j+1,i) - v(k,j,i)   )           &
-                               -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )           &
-                               +        ( v(k,j+3,i) - v(k,j-2,i) ) )         &
-                               * adv_mom_5
-                   ENDDO
-              
-               ELSE
-           
-                  DO  k = nzb_v_inner(j,i)+1, nzt
-                     u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                     flux_r(k) = u_comp * (                                   &
-                                 37.0 * ( v(k,j,i+1) + v(k,j,i)   )           &
-                              -   8.0 * ( v(k,j,i+2) + v(k,j,i-1) )           &
-                              +         ( v(k,j,i+3) + v(k,j,i-2) ) )         &
-                              * adv_mom_5
-                     diss_r(k) = - ABS( u_comp ) * (                          &
-                                 10.0 * ( v(k,j,i+1) - v(k,j,i)   )           &
-                               -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )           &
-                               +        ( v(k,j,i+3) - v(k,j,i-2) ) )         &
-                               * adv_mom_5
-                  ENDDO
-               
-               ENDIF
-         
-         
-            ELSE
-         
-               DO  k = nzb_v_inner(j,i)+1, nzt
-                  u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                  flux_r(k) = u_comp * (                                      &
-                              37.0 * ( v(k,j,i+1) + v(k,j,i)   )              &
-                            -  8.0 * ( v(k,j,i+2) + v(k,j,i-1) )              &
-                            +        ( v(k,j,i+3) + v(k,j,i-2) ) )            &
-                            * adv_mom_5
-                  diss_r(k) = - ABS ( u_comp ) * (                            &
-                              10.0 * ( v(k,j,i+1) - v(k,j,i)   )              &
-                            -  5.0 * ( v(k,j,i+2) - v(k,j,i-1) )              &
-                            +        ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
-
-                  v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                  flux_n(k) = ( v_comp(k) - gv ) * (                          &
-                              37.0 * ( v(k,j+1,i) + v(k,j,i)   )              &
-                            -  8.0 * ( v(k,j+2,i) + v(k,j-1,i) )              &
-                            +        ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
-                  diss_n(k) = - ABS( v_comp(k) - gv ) * (                     &
-                              10.0 * ( v(k,j+1,i) - v(k,j,i)   )              &
-                            -  5.0 * ( v(k,j+2,i) - v(k,j-1,i) )              &
-                            +        ( v(k,j+3,i) - v(k,j-2,i) ) ) *adv_mom_5
-
-               ENDDO
-            ENDIF
-            
-            DO  k = nzb_v_inner(j,i)+1, nzt
-               tend(k,j,i) = tend(k,j,i) - (                                  &
-              ( flux_r(k) + diss_r(k)                                         &
-            -   swap_flux_x_local_v(k,j) - swap_diss_x_local_v(k,j)   ) * ddx &
-            + ( flux_n(k) + diss_n(k)                                         &
-            -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)       ) * ddy )
-                  
-               swap_flux_x_local_v(k,j) = flux_r(k)   
-               swap_diss_x_local_v(k,j) = diss_r(k)
-               swap_flux_y_local_v(k)   = flux_n(k)     
-               swap_diss_y_local_v(k)   = diss_n(k)   
-
-               sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                             &
-                  + ( flux_n(k) * ( v_comp(k) - 2.0 * hom(k,1,2,0) )           &
-                  / ( v_comp(k) - gv + 1.0E-20 )                               &
-                  +   diss_n(k) * ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )        &
-                  / ( ABS( v_comp(k) - gv ) + 1.0E-20 ) )                      &
-                  *   weight_substep(intermediate_timestep_count)
-            ENDDO
-            sums_vs2_ws_l(nzb_v_inner(j,i),tn) = sums_vs2_ws_l(nzb_v_inner(j,i)+1,tn)
-         ENDDO
-       ENDDO
-!
-!--   Vertical advection, degradation of order near surface and top. 
-!--   The fluxes flux_d and diss_d at the surface are 0. Due to reasons of
-!--   statistical evaluation the top flux at the surface should be 0
-       DO i = nxl, nxr
-          DO  j = nysv, nyn
-!          
-!--         The fluxes flux_d and diss_d at the surface are 0. Due to static
-!--         reasons the top flux at the surface should be 0.
-             flux_t(nzb_v_inner(j,i)) = 0.0
-             diss_t(nzb_v_inner(j,i)) = 0.0
-             k      = nzb_v_inner(j,i)+1             
-             flux_d = flux_t(k-1)
-             diss_d = diss_t(k-1)
-!
-!--          2nd order scheme (bottom)
-             w_comp    = w(k,j-1,i) + w(k,j,i)
-             flux_t(k) = w_comp * ( v(k+1,j,i) + v(k,j,i) ) * 0.25
-             diss_t(k) = diss_2nd( v(k+2,j,i), v(k+1,j,i), v(k,j,i),          &
-                                   0.0, 0.0, w_comp, 0.25, ddzw(k) )
-
-             tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)              &
-                                       -   flux_d    - diss_d       ) * ddzw(k)
-!
-!--          WS3 as an intermediate step (bottom)
-             k          = nzb_v_inner(j,i) + 2
-             flux_d     = flux_t(k-1)
-             diss_d     = diss_t(k-1)
-             w_comp     = w(k,j-1,i) + w(k,j,i)
-             flux_t(k) = w_comp * (                                           &
-                         7.0 * ( v(k+1,j,i) + v(k,j,i) )                      &
-                       -       ( v(k+2,j,i) + v(k-1,j,i) ) ) * adv_mom_3
-             diss_t(k) = - ABS( w_comp ) * (                                  &
-                         3.0 * ( v(k+1,j,i) - v(k,j,i) )                      & 
-                       -       ( v(k+2,j,i) - v(k-1,j,i) ) ) * adv_mom_3
-                         
-             tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)              &
-                                       -   flux_d    - diss_d       ) * ddzw(k)
-
-!
-!-- WS5
-             DO  k = nzb_v_inner(j,i)+3, nzt-2
-                flux_d = flux_t(k-1)
-                diss_d = diss_t(k-1)
-                w_comp = w(k,j-1,i) + w(k,j,i)
-                flux_t(k) = w_comp * (                                        &
-                            37.0 * ( v(k+1,j,i) + v(k,j,i)   )                &
-                          -  8.0 * ( v(k+2,j,i) + v(k-1,j,i) )                &
-                          +        ( v(k+3,j,i) + v(k-2,j,i) ) ) * adv_mom_5
-                diss_t(k) = - ABS( w_comp ) * (                               &
-                            10.0 * ( v(k+1,j,i) - v(k,j,i)   )                & 
-                          -  5.0 * ( v(k+2,j,i) - v(k-1,j,i) )                &
-                          +        ( v(k+3,j,i) - v(k-2,j,i) ) ) * adv_mom_5
-                            
-                tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)           &
-                                          -   flux_d    - diss_d    ) * ddzw(k)
-            ENDDO
-!
-!--         WS3 as an intermediate step (top)
-            k     = nzt-1 
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            w_comp    = w(k,j-1,i) + w(k,j,i)
-            flux_t(k) = w_comp * (                                            &
-                        7.0 * ( v(k+1,j,i) + v(k,j,i)   )                     &
-                      -       ( v(k+2,j,i) + v(k-1,j,i) ) ) * adv_mom_3
-            diss_t(k) = - ABS( w_comp ) * (                                   &
-                        3.0 * ( v(k+1,j,i) - v(k,j,i)   )                     & 
-                      -       ( v(k+2,j,i) - v(k-1,j,i) ) ) * adv_mom_3
-                         
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)               &
-                                      -   flux_d    - diss_d     ) * ddzw(k)
-!
-!--         2nd order scheme (top)
-            k         = nzt
-            flux_d    = flux_t(k-1)
-            diss_d    = diss_t(k-1)
-            w_comp    = w(k,j-1,i) + w(k,j,i)
-            flux_t(k) = w_comp * ( v(k+1,j,i) + v(k,j,i) ) * 0.25
-            diss_t(k) = diss_2nd( v(nzt+1,j,i), v(nzt+1,j,i), v(k,j,i),        &
-                                  v(k-1,j,i), v(k-2,j,i), w_comp, 0.25, ddzw(k))
-
-            tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                &
-                                      -   flux_d    - diss_d       ) * ddzw(k)
-!
-!-          At last vertical momentum flux is accumulated.
-            DO  k = nzb_v_inner(j,i), nzt
-               sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                           &
-                               + ( flux_t(k) + diss_t(k) )                     &
-                               *   weight_substep(intermediate_timestep_count)
-            ENDDO
-            sums_vs2_ws_l(nzb_v_inner(j,i),tn) = sums_vs2_ws_l(nzb_v_inner(j,i)+1,tn)
-          ENDDO
-       ENDDO
+       sums_vs2_ws_l(nzb,tn) = sums_vs2_ws_l(nzb+1,tn)
+
 
     END SUBROUTINE advec_v_ws
